#include <stm32f0xx.h>
#include <stm32f0xx_conf.h>
#include <stm32f0xx_spi.h>
#include <stm32f0xx_rcc.h>
#include <stm32f0xx_gpio.h>
#include "stm32f0xx_tim.h"
#include <stm32f0xx_i2c.h>
#include "I2C.h"
#include <stdlib.h>


#define I2CADDR (0b01001000 << 1)

GPIO_InitTypeDef port;
TIM_TimeBaseInitTypeDef timer;
TIM_TimeBaseInitTypeDef TIM_SETUP; //  
TIM_OCInitTypeDef timerPWM;

uint8_t timerset=4;      //   
uint8_t mode = 0;	     //   
uint8_t color=0;         //  
uint16_t brigthness=0;   // 
uint16_t setbrightness=900;  //   
uint16_t alltime=0;    //  ,  
uint16_t settime=30;   //    
uint8_t started = 0;   //  

/*
 * started = 0 -  
 * started = 1 - 
 * started = 2 -         
 *
 */

#define MODE1_STOP  0
#define MODE1_START 1
#define MODE1_SET   2


/*
 *
 * mode = 0  -       
 * mode = 1  -   
 * mode = 2  - 
 * mode = 3  -        
 * mode = 4  -    -
 * mode = 5  - ???
 */

#define  MODE_TIMER     0
#define  MODE_STOPWATCH 1
#define  MODE_TEMP      2
#define  MODE_DICE		3
#define  MODE_RELAX		4
#define  MODE_BRIGHT	5


#define DIG0 0b00111111
#define DIG1 0b00000110
#define DIG2 0b01011011
#define DIG3 0b01001111
#define DIG4 0b01100110
#define DIG5 0b01101101
#define DIG6 0b01111100
#define DIG7 0b00000111
#define DIG8 0b01111111
#define DIG9 0b01100111
#define POINT 0b10000000
#define LED_RED   0b00000100
#define LED_BLUE  0b00000001
#define LED_GREEN 0b00000010
#define MINUS 0b01000000
#define ZERO 0b00000000



uint8_t time[3];       //    
uint8_t point[3];      //    
uint8_t point_buff[3]; //   
uint8_t time_buff[3];  //   
uint8_t mode_buff=0;   //  

uint8_t digit[]={DIG0,DIG1,DIG2,DIG3,DIG4,DIG5,DIG6,DIG7,DIG8,DIG9,MINUS,ZERO};


/*
A0 -
A1 -  1
A2 -  2
A3 -
A4 - SPI - LE
A5 - SPI - CLK
A6 - SPI - OE
A7 - SPI - SDI

A9 - I2C - SCL
A10 -I2C - SDA
B1 - SPK
*/

/*
 *        
 */

void LedShow(){
	switch (mode) {
	case MODE_TIMER:
		DataSend(LED_BLUE);
		break;
    case  MODE_STOPWATCH:
    	DataSend(LED_RED);
    	break;
    case  MODE_TEMP:
    	DataSend(0);  // 
    	break;
    case  MODE_DICE:   // 
    	DataSend(LED_GREEN);
    	break;
   /* case  MODE_RELAX:
    	break;
    case  MODE_BRIGHT:
    	break;
   */
    	default:
     DataSend(0);
	}

}


/*
 *   ,   
 *
 *
 */
void  Clear(void)
{
	TIM3->CCR1=1050;
	LedShow();   //  
	DataSend(0);
	DataSend(0);
	DataSend(0);
	TIM3->CCR1=setbrightness;
}

/*
 *     ,  ,   
 *    ,      
 *
 *
 */
uint8_t IsChanged(){
	if (mode!=mode_buff){
		return 1;
	}
	uint8_t i=0;
	for (i=0;i<3;i++){
		if (time[i]!=time_buff[i]){
			return 1;
		}
		if (point[i]!=point_buff[i]){
			return 1;
		}
	 }
	return 0;

}



/*
 *  
 */
void Refresh(void)
{
	TIM3->CCR1=1050;
	//delay_ms(10);
    LedShow();  //   
    uint8_t i=0;
    for (i=0;i<3;i++){
    	DataSend(digit[time[i]]^point[i]);
    	time_buff[i]=time[i];
    	point_buff[i]=point[i];
    }
    /*
	DataSend(digit[time[1]]^point[1]);
	DataSend(digit[time[2]]^point[2]);
time_buff[0]=time[0];
	time_buff[1]=time[1];
	time_buff[2]=time[2];
*/
	mode_buff=mode;
	TIM3->CCR1=setbrightness;
}
/*
 *         
 */

void Blink(uint8_t Num)
{
	TIM3->CCR1=1050;
	LedShow();

	if (Num == 0){
		DataSend(0);
		DataSend(digit[time[1]]);
		DataSend(digit[time[2]]);
	}
	if (Num == 1){
		DataSend(digit[time[0]]);
		DataSend(0);
			DataSend(digit[time[2]]);
	}
	if (Num == 2){
		DataSend(digit[time[0]]);
		DataSend(digit[time[1]]);
		DataSend(0);
	}
	TIM3->CCR1=setbrightness;
}


//    SPI
void DataSend(uint16_t data)
{
	GPIO_SetBits(GPIOA, GPIO_Pin_4);
	while (SPI_I2S_GetFlagStatus(SPI1, SPI_I2S_FLAG_BSY) == SET);
	GPIO_ResetBits(GPIOA, GPIO_Pin_4);
	delay_ms(1);


	SPI_SendData8(SPI1, data);//   8 ,      4 
    while(SPI_I2S_GetFlagStatus(SPI1, SPI_I2S_FLAG_BSY) == SET) // ?
	      ; //    
    delay_ms(1);
    GPIO_SetBits(GPIOA, GPIO_Pin_4);
  //  GPIO_ResetBits(GPIOA, GPIO_Pin_4);
}

//void init_I2C1(void);
void I2C_StartTransmission(I2C_TypeDef* I2Cx, uint8_t transmissionDirection,  uint8_t slaveAddress);
void I2C_WriteData(I2C_TypeDef* I2Cx, uint8_t data);
uint8_t I2C_ReadData(I2C_TypeDef* I2Cx);


//   
void delay_ms(uint32_t ms)
{
	volatile uint32_t nCount; //  
	RCC_ClocksTypeDef RCC_Clocks; //    
	RCC_GetClocksFreq (&RCC_Clocks); //   

	nCount=(RCC_Clocks.HCLK_Frequency/10000)*ms; //   
	for (; nCount!=0; nCount--); //  
}
void Delay1(uint32_t nCount) {
	for (; nCount != 0; nCount--);
}

/*
 * 
 */
void Beep(void)
{
	int k=0;
	  for(k=0;k<200; k++){
	  	  GPIO_SetBits(GPIOB, GPIO_Pin_1);
	  	Delay1(600);
	  	  GPIO_ResetBits(GPIOB, GPIO_Pin_1);
	  	Delay1(100);
	  }


}

/*******************************************************************/
void initAll()
{
    //   
	RCC->CR|=RCC_CR_HSEON; //  HSE.
	while (!(RCC->CR & RCC_CR_HSERDY)) {}; //  
	RCC->CFGR &=~RCC_CFGR_SW; // 
	RCC->CFGR |= RCC_CFGR_SW_HSE; //   HSE 8M


	//   TIM3  
    // 3      APB1
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM3, ENABLE);

	// 14      APB1
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM14, ENABLE);

    //     B
  	RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOA, ENABLE);
  	RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOB, ENABLE);

  	//  
  	GPIO_InitTypeDef GPIO_InitStructure;

  	// a6  
  	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_6;
  	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;//GPIO_Mode_OUT;

  	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_Level_3;
  	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_DOWN;
   	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP; // -
   	GPIO_Init( GPIOA , &GPIO_InitStructure);
   	GPIO_PinAFConfig(GPIOA,GPIO_PinSource6,GPIO_AF_1);


  	//  3

   	TIM_SETUP.TIM_CounterMode = TIM_CounterMode_Up;  // 
   	TIM_SETUP.TIM_Period = 1023;     //  1023 
   	TIM_SETUP.TIM_Prescaler = 0;    // 
   	TIM_TimeBaseInit(TIM3, &TIM_SETUP);

   	TIM_OCInitTypeDef PWM_SETUP;  //  
   	PWM_SETUP.TIM_Pulse = 0; //  
   	PWM_SETUP.TIM_OCMode = TIM_OCMode_PWM1; //1 center align
   	PWM_SETUP.TIM_OutputState =TIM_OutputState_Enable; //  
   	PWM_SETUP.TIM_OCPolarity = TIM_OCPolarity_High; // 
   	TIM_OC1Init(TIM3, &PWM_SETUP);
   	TIM_Cmd(TIM3, ENABLE);
   	TIM3->CCR1=setbrightness;  //     




  /*
   	// a6   
   	   	GPIO_InitStructure.GPIO_Pin = LED1_PIN;
   	   	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
   	   	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_Level_3;
   	   	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_DOWN;
   	   	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP; // -
   	   	GPIO_Init( LED_PORT , &GPIO_InitStructure);
*/

   	// a4  
   	   	GPIO_InitStructure.GPIO_Pin   = GPIO_Pin_4    ;
   	   	GPIO_InitStructure.GPIO_Mode  = GPIO_Mode_OUT;
   	   	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_Level_1;
   	   	GPIO_InitStructure.GPIO_PuPd  = GPIO_PuPd_NOPULL;
   	   	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP; // -
   	   	GPIO_Init(GPIOA, &GPIO_InitStructure);

   	   	// a1,a2  
  	   	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_1 | GPIO_Pin_2;
   	   	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN;
   	   	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_Level_3;
   	   	GPIO_InitStructure.GPIO_PuPd =GPIO_PuPd_NOPULL;  //    
   	   	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP; // -
	   	GPIO_Init(GPIOA, &GPIO_InitStructure);



   	   	// b1   
   	    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_1;
   	   	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
   	   	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_Level_1;
   	   	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_DOWN;
   	   	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP; // -
   	   	GPIO_Init(GPIOB, &GPIO_InitStructure);


   	  SPI_InitTypeDef SPI_InitStructure;

   	  //   SPI1   
   	  RCC_APB2PeriphClockCmd(RCC_APB2Periph_SPI1, ENABLE);

   	  //   SPI1      
   	  GPIO_PinAFConfig(GPIOA, GPIO_PinSource7, GPIO_AF_0);
   	  GPIO_PinAFConfig(GPIOA, GPIO_PinSource5, GPIO_AF_0);

   	  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
   	  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
   	  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
   	  //GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_DOWN;
   	  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_7 | GPIO_Pin_5;
   	  GPIO_Init(GPIOA, &GPIO_InitStructure);

   	  //    SPI  SPI_Direction_1Line_Tx;
   	  SPI_InitStructure.SPI_Direction =SPI_Direction_2Lines_FullDuplex; // 
   	  SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b; //   8 
   	  SPI_InitStructure.SPI_CPOL = SPI_CPOL_Low;// SPI_CPOL_Low; //  
   	  SPI_InitStructure.SPI_CPHA = SPI_CPHA_1Edge; //   
   	  SPI_InitStructure.SPI_NSS = SPI_NSS_Soft; //    NSS 
   	  SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_2; //  SCK
   	  SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB; //    
   	  SPI_InitStructure.SPI_Mode = SPI_Mode_Master; //  - 
   	  SPI_Init(SPI1, &SPI_InitStructure); // SPI1
   	  SPI_Cmd(SPI1, ENABLE); //   SPI1....

   	  //   NSS  ,    
   	  //     ,   SPI  , 
   	  //         .
   	  SPI_NSSInternalSoftwareConfig(SPI1, SPI_NSSInternalSoft_Set);




  	// 14    

	  	TIM_SETUP.TIM_CounterMode = TIM_CounterMode_Up;  // 
 	  	TIM_SETUP.TIM_Period = 100;     //  1/10 
 	  	TIM_SETUP.TIM_Prescaler =8000 ; //TIMER_PRESCALER;    // 
 	  	TIM_TimeBaseInit(TIM14, &TIM_SETUP);


   	//  
   		TIM_ITConfig(TIM14, TIM_IT_Update, ENABLE);
   		TIM_Cmd(TIM14, ENABLE);
   		NVIC_EnableIRQ(TIM14_IRQn);


   		//  I2C

     	RCC_APB1PeriphClockCmd(RCC_APB1Periph_I2C1, ENABLE);
   	  	RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOA, ENABLE);

 	  	GPIO_PinAFConfig(GPIOA, GPIO_PinSource9, GPIO_AF_4);
  	  	GPIO_PinAFConfig(GPIOA, GPIO_PinSource10, GPIO_AF_4);

  	  	// i2C 

 	  	GPIO_StructInit(&GPIO_InitStructure);
 	  	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9|GPIO_Pin_10;
 	  	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
  	  	//GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;   //      
 	  	GPIO_InitStructure.GPIO_OType = GPIO_OType_OD;
   	  	GPIO_Init(GPIOA, &GPIO_InitStructure);

   	  	I2C_InitTypeDef I2C_InitStructure;

   	  	I2C_InitStructure.I2C_Mode = I2C_Mode_I2C;//I2C_Mode_SMBusHost;
 	  	I2C_InitStructure.I2C_AnalogFilter = I2C_AnalogFilter_Enable;
  	  	I2C_InitStructure.I2C_DigitalFilter = 0x00;
  	  	I2C_InitStructure.I2C_OwnAddress1 = 0x00;
  	  	I2C_InitStructure.I2C_Ack = I2C_Ack_Enable;
   	  	I2C_InitStructure.I2C_AcknowledgedAddress = I2C_AcknowledgedAddress_7bit;
  	  	I2C_InitStructure.I2C_Timing = 0xC062121F;

 	  	I2C_Init(I2C1, &I2C_InitStructure);
	  	I2C_Cmd(I2C1, ENABLE);

}
/*
 *     
 */
uint16_t ReadTemp(){

    uint16_t cou;
    uint8_t dec;
    uint8_t buff[2];

    buff[0]=0;
    buff[1]=0;

    time[0] = 0;
    time[1] = 0;
    time[2] = 0;
    point[0] = 0;
    point[1] = 0;
    point[2] = 0;

    // 
    cou=I2C_Read_Transaction (I2CADDR, 0x00, buff, 2);
    if (cou!=2){   //  
    	return 0;
    }
	  uint16_t temp;
	  int hi,lo;

	  temp  = buff[0]<<8;
	  temp|= buff[1]&0xE0;
	  hi = temp>>8;
	  if (temp<0) {

		  //lo = ((8-(temp>>5))&7);    
		  lo = ((temp>>5)&7);
		  lo=8-lo;

		  dec = hi/10;
		  time[1] = dec;
		  time[0] = hi-dec*10;
		  time[2] = 10;   //  
	      point[0] = POINT;

	  } else {
		      lo = ((temp>>5)&7);
		      lo*=125;
		      dec = hi/10;
		      time[2] = dec;
		      time[1] = hi-dec*10;
		      time[0] = lo/100;
		     point[1] = POINT;
	  }
}




void TimerA1(){   //   a1   
	switch (started){
	case MODE1_SET:
		 if (timerset==2){   //   
		   		time[2]++;
		   		if (time[2]>9){
		   			time[2]=0;
		   		}

		  }else   if (timerset==1){   //   
		   		time[1]++;
		   		if (time[1]>9){
		  			time[1]=0;
		   		}
		   		//Refresh();
		  } else if (timerset==0){
   	    		time[0]++;
	 	    		if (time[0]>9){
		  	    			time[0]=0;
	   	    		}

	   	  }
		 settime = time[2]*100+time[1]*10+time[0];
		 Refresh();

		break;
	case MODE1_START:
		started =MODE1_STOP;
		alltime=settime;
		Refresh();
		break;
	case MODE1_STOP:   // ,   
		alltime=settime*10;  //      
		started =MODE1_START;
		break;

	}

  }



int main(void) {

	__enable_irq();   //  
	initAll();        //  

	uint8_t data = 0;
	uint16_t x1,i;
	delay_ms(100);
	GPIO_SetBits(GPIOA, GPIO_Pin_4);   //    
//	GPIO_ResetBits(GPIOA, GPIO_Pin_6);   //   

	Beep();

	  uint8_t button_flag=0;
	  uint8_t button2_flag=0;
	//  uint8_t On=0;
	  uint8_t tmp=0;

	  alltime = settime*10;
	  time[0]=settime/100;
	  time[1]=(settime-time[0]*100)/10;
	  time[2]=(settime-time[0]*100-time[1]*10);
	  time_buff[0]=0;
	  time_buff[1]=0;
	  time_buff[2]=0;
      Refresh();
	 /*
      DataSend(0);
	  DataSend(0);
	  DataSend(0);
	  DataSend(0);

	  DataSend(LED_BLUE);
	  DataSend(digit[time[0]]);
	  DataSend(digit[time[1]]);
	  DataSend(digit[time[2]]);
*/

	  while(1) {
		if (mode==0){    // 

		/*	if (timerset==3){ //  
						delay_ms(100);
						Clear();
						delay_ms(100);
						Refresh();

			}
		*/
			if (timerset<3){ //   
						delay_ms(100);
						Blink(timerset);
						delay_ms(100);
						Refresh();
			}
		}
		if (mode==1){

		}
		if (mode==2){     // 
		//	 ReadTemp();
		//	 if (IsChanged()==1){
		//		 Refresh();
		//	 }
		}

		if ((GPIOA->IDR & 0x06)==0x06) {  //   
			if (mode==MODE_TIMER) {
				if (started!=MODE1_SET){   //  
					started=MODE1_SET;
					timerset=2;
					alltime = settime*10;
						  time[0]=settime/100;
						  time[1]=(settime-time[0]*100)/10;
						  time[2]=(settime-time[0]*100-time[1]*10);
				} else {
					started=MODE1_STOP;
					timerset=4;
				}

			/*   if (timerset==3) {
				   timerset=4;
			   } else {
				   timerset=3;
			   }
			 */

			} else if (mode==MODE_DICE){
				if (started!=MODE1_SET){   //  
					started=MODE1_SET;
					  time[0]=5;
					  time[1]=10;
					  time[2]=5;
				} else {
					started=MODE1_STOP;

				}

			}
		}
		/*
		 *
		 * mode = 0  -       
		 * mode = 1  -   
		 * mode = 2  - 
		 * mode = 3  -        
		 * mode = 4  -    
		 * mode = 5  - ???
		 */
		if ((GPIOA->IDR & 0x02)==0x02 & ((GPIOA->IDR & 0x04) != 0x04)) { // A1   
	      if (!button_flag) {
	    	  button_flag=1;
	    	  if (mode==0) {

	    		  TimerA1();
	    	  } else if (mode==1){
	    		 if (started==0) {
	    			 started = 1;
	    			 alltime =0;
	    	 		 point[0] = 0;
	    		     point[1] = 0;
	    		     point[2] = 0;
	    		     point[2]=POINT;

	    		 } else {
	    			 started = 0;
	    		  }
	    		 }
	    	  } else if (mode==MODE_DICE){
	    		     switch (started) {
	    		     case MODE1_STOP:
		    			 started = 1;
		    			 alltime = 0;
	    		    	 break;
	    		     case MODE1_START:
	    		    	 break;
	    		     case MODE1_SET:
	    		    	 setbrightness=setbrightness+50;
	    		    	 if (setbrightness>1000){
	    		    	    setbrightness = 700;
	    		    	 }
	    		    	 TIM3->CCR1=setbrightness;
	    		    	 break;
	    		     }



	         }  else if (mode==4){
	    		 if (started==0) {
	    			 started = 1;
	    			 alltime = 0;

	    		 } else {started = 0;}


         }

	      delay_ms(100);
	      } else {

	      button_flag=0;

	    }

		if((GPIOA->IDR & 0x04) == 0x04 & (GPIOA->IDR & 0x02)!=0x02){ // A2  3- 
	   	        if (!button2_flag){  //    
	   	    	  button2_flag = 1;
	   	    	  if (mode ==MODE_TIMER) {
	   	    			  point[0] = 0;
	   	 	    		  point[1] = 0;
	   	 	    		  point[2] = 0;
	   	 	    		switch (started){
	   	 	    			case MODE1_SET:

	   	 	    				 if (timerset==2){   //   
	   	 	    				  		timerset=1;
	   	 	    				  }else   if (timerset==1){   //   
	   	 	    				  		timerset=0;
	   	 	    				  } else if (timerset==0){
	   	 	    				  		 timerset=4;
	   	 	    				  		 started=MODE1_STOP;
	   	 	    				  }
	   	 	    				break;
	   	 	    			case MODE1_STOP:
	   	 	    				mode=MODE_STOPWATCH;
	   	 	    				started = MODE1_STOP;
	   	 	    				alltime=0;
	   	 	    				time[0]=0;
	   	 	    				time[1]=0;
	   	 	    				time[2]=0;
	   	 	    			    point[2] = POINT;
	   	 	    				break;
	   	 	    		    case MODE1_START:
	   	 	    		    	mode=MODE_STOPWATCH;
	   	 	    		    	started = MODE1_STOP;
	   	 	    		    	alltime=0;
	   	 	    		    	time[0]=0;
	   	 	    		    	time[1]=0;
	   	 	    		    	time[2]=0;
	   	 	    		        point[2] = POINT;
    				  			break;

	   	 	    		    }

	   	 	    		 // TimerA2();   //  
	   	    			 if (IsChanged()==1){
	   	    					 Refresh();
	   	    			 }
	   	    	  } else
	   	    	  if (mode ==1){
	   	    		  mode=2;

	   	    	  } else
	   	    	  if (mode==2){
	   	    		  mode = 3; // 
	   	    		 started=0;
	   	    		 alltime=0;
	   	    		 point[0] = 0;
	   	    		 point[1] = 0;
	   	    		 point[2] = 0;
	   	    	     time[0]=10;  // 
	   		   	     time[1]=11;  // 
	   		   	     time[2]=10;  // 


	   	    		 if (IsChanged()==1){
	   	    				 Refresh();
	   	    		 }
	   	    	  } else
	   	    	 if (mode==3){
	   	    		  mode = 4;
	   	    		started=1;
	   	    		DataSend(LED_RED^LED_GREEN);
	   	    		DataSend(0);
	   	    		DataSend(0);
	   	    		DataSend(0);

	   	    		time[0]=11;  //
    		   	    time[1]=11;  // 
	   	    		time[2]=11;  //
	   	    		brigthness=750;  //  
	   	    		color=LED_GREEN;

	   	    	} else
	   	    	if (mode==4){
	   	    	  mode = 0;
	   	    	 started=0;
	   	    	 alltime=settime*10;
				 time[2]=settime/100;
				 time[1]=(settime-time[2]*100)/10;
				 time[0]=(settime-time[2]*100-time[1]*10);
	   	    	  point[0]=0;
	   	    	  point[1]=0;
	   	    	  point[2]=0;
	   	    	}

	   	  	    	 delay_ms(10);
	   	      }
	   		  } else {
	   			  button2_flag = 0;
	   		  }
	  }
 	return 0;
}




/*******************************************************************/

uint8_t down=0;

 void TIM14_IRQHandler()
{
//      
	uint8_t _0,_1,_2;
	uint16_t all;
	rand();   //    
	if (mode==MODE_TIMER){  //
	  switch (started){
	  case MODE1_START:
		  if (alltime==0){   //     
			    Beep();
			    time[0]=0;
		    	time[1]=0;
		    	time[2]=0;
		    	if (IsChanged()==1){
		    	   		Refresh();
		    	}

		    	started = MODE1_STOP; //  
		    	TIM_ClearITPendingBit(TIM14, TIM_IT_Update);
		    	return;
		   }
		   alltime--;
		   all = alltime/10;
		   _2 = all/100;
		   _1 = (all-(_2*100))/10;
		   _0 = all-(_2*100)-(_1*10);
		   time[0]=_0;
		   time[1]=_1;
		   time[2]=_2;
		  break;
	  case MODE1_STOP:   //   
		  break;
	  case MODE1_SET:
		  break;
	  }
	}
   if (mode==MODE_STOPWATCH) {   // 
	   if (alltime==6000){   // 10 
		   Beep();
		   alltime=0;
		   time[0]=0;
		   time[1]=0;
		   time[2]=0;
		   point[2]=POINT;
	 }
     if (started==0){   //     
	  	TIM_ClearITPendingBit(TIM14, TIM_IT_Update);
	       	return;
      }

       alltime++;
       all = alltime/10;
       /*   */
       point[2]=0;
           _2 = all/100;
            _1 = (all-(_2*100))/10;
           _0 = all-(_2*100)-(_1*10);
       /*     */
           _2 = all/60;

           _1 = (all-(_2*60))/10;
           _0 = all-(_2*60)-(_1*10);
           point[2]=POINT;
           time[0]=_0;
           time[1]=_1;
           time[2]=_2;
    }
    if (mode==2){     // 
    			 ReadTemp();
   	}

    if (mode==3){
    	if (started==1) {
    		alltime++;
    		time[0] = rand() % 6 + 1;
    		time[2] = rand() % 6 + 1;
    		if (alltime>30){
    			started = 0;
    			alltime =0;
    		}
       	}


   	}
    if (mode==4){    // 
        	if (started==1) {
        		if (down==1){
        			brigthness=brigthness-10;
        		} else {
        			brigthness=brigthness+10;
        		}
        		if (brigthness<700){
        			down=0;
        		}
        		if (brigthness>1100){
        			down=1;
        			switch ( color ) {
        			  case LED_GREEN:
        			     color = LED_BLUE;
        			     break;
        			  case LED_BLUE:
        				  color = LED_RED;
        				  break;
        			  case LED_RED:
        				  color = LED_GREEN;
        				  break;
        			}
        		     DataSend(color);
        		     DataSend(0);
        		     DataSend(0);
        		     DataSend(0);

        		}

        		TIM3->CCR1=brigthness;

           	}
        	TIM_ClearITPendingBit(TIM14, TIM_IT_Update);
        	return;
    }



    if (IsChanged()==1){
   				 Refresh();
   	}

    TIM_ClearITPendingBit(TIM14, TIM_IT_Update);

}

